//a configuration is a set of activeTask 
//we define in configuration also the global clock
import java.util.*;

public class Configuration {
	
	public static int globalClock;
	
	HashSet<ActiveTask> conf;
		
	//constructor
	public Configuration(){
		conf = new  HashSet<ActiveTask>();
		globalClock = 0;
	}
	
	
	//add active task to configuration
	public void addActiveTask(ActiveTask at){
		conf.add(at);
	}
	
	
	//ENABLED returns the set of task enabled at time gc. 
	public HashSet<ActiveTask> enabled(){
		HashSet<ActiveTask> activeBT = new HashSet<ActiveTask>();
		for(ActiveTask at : conf){   
			if(!at.t.completed()){
			   if(globalClock - at.timeStamp >= at.t.hd().waitingTime) {    //CAMBIATO E MESSO MAGGIORE UGUALE
				  activeBT.add(at);
			   }
			}
		}
		return activeBT;
	}
	
	//metodo che mi restituisce dalla configurazione tutti i task non terminati ma in pausa
		public HashSet<ActiveTask> waitingTasks(){
			HashSet<ActiveTask> activeBT = new HashSet<ActiveTask>();
			for(ActiveTask at : conf){   
				if(!at.t.completed()){
				if(globalClock - at.timeStamp < at.t.hd().waitingTime) {    
					activeBT.add(at);
				}
				}
			}
			return activeBT;
		}
	
		
	//completed method returns true if for each triple in the configuration the task T is accomplished
	public boolean completed(){
		for(ActiveTask at : conf){
			if(!at.t.completed()){
				return false;
			}
		}
		return true;
	}
	
	//to print configuration
	public void ToString(){
		String result="";
		if(conf.size()>0){
			for(ActiveTask at : conf){
				result += at.AtToString() + at.t.TToString();
			}
		}
		System.out.println(result); 
		System.out.println();
	}
	
	
}